{%extends 'Base.html'%}
{%load static%}
{%block title%}Home{%endblock title%}
{%block css%}
<link rel="stylesheet" type="text/css" href="{%static 'Bootstrap/css/Home.css'%}">
{%endblock css%}
{%block content%}
{%block viewcart%}
<div id="heading_container">
  <div>
    <h1>Medicine List</h1>
    {%if messages %}
    {%for message in messages%}
    <p>{{message}}</p>
    {%endfor%}
    {%endif%}
  </div>
  <div>
    <!-- add modal  -->
    <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#Add-Medicine-form">
      Add Medicine
    </button>
    <div class="modal fade " id="Add-Medicine-form" tabindex="-1" role="dialog"
      aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered modal-dialog modal-lg" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLongTitle">Add New Medicine</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>

          <div class="modal-body">
            <form action="addMedicine" method="POST" autocomplete="off">
              {% csrf_token %}
              <div class="form-group">
                <label for="exampleInputEmail1">Drug_Code</label>
                <input type="number" required class="form-control" name="Drcode" id="exampleInputEmail1"
                  placeholder="Enter Drug_Code">
              </div>
              <div class="form-group">
                <label for="exampleInputEmail1">Medicine Name</label>
                <input type="text" required class="form-control" name="Mname" id="exampleInputEmail1"
                  placeholder="Enter Medicine Name">
              </div>

              <div class="form-group">
                <label for="exampleInputEmail1">Unit Size</label>
                <input type="number" required class="form-control" name="unit" value=10 min=1 id="exampleInputEmail1"
                  placeholder="Enter Unit Size">
              </div>
              <div class="form-group">
                <label for="exampleInputEmail1">Unit</label>
                <select class="form-select" name='unitsize' aria-label="Default select example">
                  <option>Select Unit size</option>
                  <option selected name='unitsize' value="NOS">Nos</option>
                  <option name='unitsize' value="ML">Milligram</option>
                </select>
              </div>
              <div class="form-group">
                <label for="exampleInputEmail1">MRP</label>
                <input type="number" required min=1 step="0.01" class="form-control" name="mrp" id="exampleInputEmail1"
                  placeholder="Enter MRP">
              </div>
              <!-- <input type="submit" value="Save Medicine" class="btn btn-primary">
              <input type="reset" value="Reset" class="btn btn-danger"> -->

          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
            <input type="reset" value="Reset" class="btn btn-danger">
            <input type="submit" value="Save Medicine" class="btn btn-primary">
            <!-- <button type="button" class="btn btn-primary">Save changes</button> -->
          </div>
          </form>
        </div>
      </div>
    </div>
    <!-- add modal  -->

    <!-- View cart Modal -->
    <button type="button" class="btn btn-primary" onclick="View_Cart();" id="viewcart_btn" data-toggle="modal"
      data-target="#viewcart">
      View Cart<sup id="cart_count" style="font-size:20px">0</sup>
    </button>
    <div class="modal fade " id="viewcart" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle"
      aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered modal-dialog modal-lg" id="modal-lg" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="exampleModalLongTitle">Your Cart</h5>

            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <form action="Save_Bill" method="post">
            {% csrf_token %}
            <div class="modal-body">
              <table class="table" id="viewcart_table">
                <thead id="viewcart_table_thead">
                  <tr>
                    <!-- <th scope="col">S.NO</th> -->
                    <th scope="col">Drug_Code</th>
                    <th scope="col">Medicine_Name</th>
                    <th scope="col">Qty</th>
                    <th scope="col">MRP</th>
                    <th scope="col">Total</th>
                    <th scope="col">Remove</th>
                  </tr>
                </thead>
              </table>
            </div>
            <div class="modal-footer">
              <p class="h4">Sum Items:
              <p class="h4" id="item_count">0</p>
              <p class="h4">Items</p>
              <p class="h4">|</p>
              <p class="h4">Grand Total:</p>
              </p>
              <p class="h4">Rs.
              <p class="h4" id="total_p">0.00</p>
              </p>
              <button type="button" class="btn btn-secondary" id="G_Total">Grand Total</button>
              <button type="button" class="btn btn-secondary" id="RemoveAll">Remvoe All</button>
              <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
              <button type="button" class="btn btn-primary" onclick="Bill_Print();" id="save_print">Print
              </button>
              <button type="submit" class="btn btn-primary" onclick="Bill_Print();" id="save_print">Save
                changes</button>
          </form>
        </div>
      </div>
    </div>
  </div>
  <!-- View cart Modal -->
</div>
</div>
{%endblock viewcart%}
{% if user.is_authenticated %}
Hi {{ user.username }}!
{% else %}
<p>You are not logged in</p>
<a href="{% url 'login' %}">Log In</a>
{% endif %}

{%block searchbox%}
<!-- <input type="search" name="" onkeyup="Search();" id="search" placeholder="Medicine Search..."> -->
{%endblock searchbox%}

<table class="table" id="medicine-list">
  <thead>
    <tr>
      <th>S.NO</th>
      <th scope="col" width="10%"><input type="search" autocomplete="off" class="form-control" name=""
          onkeyup="Drug_Code_Search();" id="Drug_Code_Search" placeholder="Drug_Code"></th>
      <th scope="col" width="50%"><input type="search" autocomplete="off" class="form-control" name=""
          onkeyup="Search();" id="search" placeholder="Medicine_Name"></th>
      <th scope="col" width="10%">Unit Size</th>
      <th scope="col" width="10%">MRP</th>
      <th scope="col" width="10%">Add To Cart</th>
    </tr>
  </thead>
  <tbody>
    {% for item in medicine_list %}
    <tr>
      <td>{{forloop.counter}}</td>
      <td>{{item.drug_code}}</td>
      <td>{{item.medicine_name}}</td>
      <td>{{item.unit}}_{{item.unit_size}}</td>
      <td>{{item.mrp}}</td>
      <td>
        <button type="button" class="btn btn-success"
          onclick="addtocart({{item.drug_code}},{{item.mrp}},'{{item.medicine_name}}')">Add To
          Cart</button>
      </td>
      {%endfor%}
    </tr>

  </tbody>
</table>

{%endblock content%}
{%block js%}

<script>

  function Search() {
    // Declare variables
    var input, filter, table, tr, td, i, txtValue;
    input = document.getElementById("search");
    filter = input.value.toUpperCase();
    table = document.getElementById("medicine-list");
    tr = table.getElementsByTagName("tr");

    // Loop through all table rows, and hide those who don't match the search query
    for (i = 0; i < tr.length; i++) {
      td = tr[i].getElementsByTagName("td")[2];


      if (td) {
        txtValue = td.textContent || td.innerText;
        if (txtValue.toUpperCase().indexOf(filter) > -1) {
          tr[i].style.display = "";
        } else {
          tr[i].style.display = "none";
        }
      }
    }
  }
  function Drug_Code_Search() {
    // Declare variables
    var input, filter, table, tr, td, i, txtValue;
    input = document.getElementById("Drug_Code_Search");
    filter = input.value.toUpperCase();
    table = document.getElementById("medicine-list");
    tr = table.getElementsByTagName("tr");

    // Loop through all table rows, and hide those who don't match the search query
    for (i = 0; i < tr.length; i++) {
      td = tr[i].getElementsByTagName("td")[1];


      if (td) {
        txtValue = td.textContent || td.innerText;
        if (txtValue.toUpperCase().indexOf(filter) > -1) {
          tr[i].style.display = "";
        } else {
          tr[i].style.display = "none";
        }
      }
    }
  }

  var drug_code_cart = [];

  var dr_cart = {};
  var items = [];


  function addtocart(drug_code, mrp, medicine_name) {

    var includ = drug_code_cart.includes(drug_code);
    var qty_td = document.createElement("td");
    var qty_input = document.createElement("input");
    qty_input.type = 'number';
    qty_input.value = 1;
    qty_input.name = "qty";
    qty_input.min = 1;
    qty_input.id = "id_qty"
    qty_input.style.width = "50px";
    var total_td = document.createElement("td");
    total_td.innerHTML = mrp;
    total_td.name = "total";

    if (includ) {
      var ex_qty = Number(qty_input.value);

      console.log("already Exist");
    } else {
      drug_code_cart.push(drug_code);


      let D_code = drug_code;
      let MRP = mrp;
      let qty = 1;
      let medi_name = medicine_name;
      dr_cart.items = items;
      var iteminclue = items.includes(D_code)
      var item = { D_code, MRP, medi_name, qty };
      dr_cart.items.push(item);
      if (iteminclue) {
        console.log("Qty:");
      }
      console.log(dr_cart);


      var Grand_Total = 0;

      var tr = document.createElement("tr");
      tr.id = "viewcart_tr";
      var dr_code_td = document.createElement("td");
      var drcd = document.createTextNode(drug_code);
      dr_code_td.append(drcd);

      var m_name = document.createElement("td");
      var Mname = document.createTextNode(medicine_name);
      m_name.append(Mname);
      qty_td.append(qty_input);

      var m_mrp = document.createElement("td");
      var mmrp = document.createTextNode(mrp);
      m_mrp.append(mmrp);


      var Remove_btn_td = document.createElement("td");
      var Remove_btn = document.createElement("button");
      Remove_btn.innerHTML = "Remove";
      Remove_btn.id = "id_Remove"

      Remove_btn.className = "btn btn-danger";
      Remove_btn_td.append(Remove_btn);

      tr.appendChild(dr_code_td);
      tr.appendChild(m_name);
      tr.appendChild(qty_td);
      tr.appendChild(m_mrp);
      tr.appendChild(total_td);
      tr.appendChild(Remove_btn_td);
      document.getElementById("viewcart_table").appendChild(tr);
      var vtable = document.getElementById("viewcart_table");
      var row_count = vtable.rows.length - 1;

      document.getElementById('cart_count').innerHTML = row_count;
      document.getElementById('item_count').innerHTML = row_count;

      qty_input.addEventListener("change", () => {
        total_td.innerHTML = mrp * qty_input.value;
        var t = Number(total_td.innerHTML).toFixed(2);
        total_td.innerHTML = t;
      });
      Remove_btn.addEventListener("click", () => {
        tr.remove();
        document.getElementById('cart_count').innerHTML = vtable.rows.length - 1;
        document.getElementById('item_count').innerHTML = vtable.rows.length - 1;
        document.getElementById('total_p').innerHTML = Grand_Total;
      });
      var Remove_All_btn = document.getElementById('RemoveAll');
      Remove_All_btn.addEventListener("click", () => {
        let text = "Do you want to Remove all items.";
        if (confirm(text) == true) {
          // tr.remove();
          // document.getElementById('cart_count').innerHTML = vtable.rows.length - 1;
          // document.getElementById('item_count').innerHTML = vtable.rows.length - 1;
          // document.getElementById('total_p').innerHTML = Grand_Total;
          location.reload();
        }
      });

      var Total_btn = document.getElementById('G_Total');
      Total_btn.addEventListener("click", () => {
        var Grand_Total = 0;
        for (i = 1; i < vtable.rows.length; i++) {
          total = Number(vtable.rows[i].cells[4].innerHTML);
          Grand_Total += total;
        }
        document.getElementById('total_p').innerHTML = Grand_Total.toFixed(2);
      });
    }

  }


  function View_Cart() {
    var bill_table = document.getElementById('viewcart_tr');
    if (bill_table == null) {
      alert("Add Atleast One items")
      location.reload();
    }
  }

  function Bill_Print() {
    var B_Number = 0;
    // dateTime
    var today = new Date();
    var date = today.getFullYear() + '-' + (today.getMonth() + 1) + '-' + today.getDate();
    var time = today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
    var dateTime = date + ' ' + time;
    // dateTime
    var printWindow = window.open('', '', 'height=1500,width=2000');
    printWindow.document.write('<html><head><title>Table Contents</title>');

    //Print the Table CSS.
    var viewcart_table = document.getElementById("viewcart_table");
    printWindow.document.write('<style type = "text/css">');
    printWindow.document.write('table,th,td{border: 1px solid;}');
    printWindow.document.write('table{width:100%;}');
    printWindow.document.write('table{text-align: center;}');
    // printWindow.document.write('#sum{}');
    printWindow.document.write('</style>');
    printWindow.document.write('</head>');

    //Print the DIV contents i.e. the HTML Table.
    printWindow.document.write('<body>');
    printWindow.document.write('<center><h1>Amra Skin Care</h1></center>');
    printWindow.document.write('Customer Copy')
    printWindow.document.write('<hr>')
    printWindow.document.write("Date:", dateTime);
    printWindow.document.write("Bill No:", B_Number)
    printWindow.document.write('<table>');
    printWindow.document.write('<tr><td>Qty</td><td>Items</td><td>MRP</td><td>Total</td><tr>');
    let sumItems = document.getElementById('item_count').innerHTML;
    let sumTotal = document.getElementById('total_p').innerHTML;
    for (let i = 1; i < viewcart_table.rows.length; i++) {
      let qty = viewcart_table.rows[i].cells[2].children.qty.value;
      let Mname = viewcart_table.rows[i].cells[1].innerHTML;
      let M_mrp = viewcart_table.rows[i].cells[3].innerHTML;
      let total = viewcart_table.rows[i].cells[4].innerHTML;

      // console.log();
      printWindow.document.write('<tr>');
      printWindow.document.write('<td>');
      printWindow.document.write(qty);
      printWindow.document.write('</td>');

      printWindow.document.write('<td>');
      printWindow.document.write(Mname);
      printWindow.document.write('</td>');

      printWindow.document.write('<td>');
      printWindow.document.write(M_mrp);
      printWindow.document.write('</td>');

      printWindow.document.write('<td>');
      printWindow.document.write(total);
      printWindow.document.write('</td>');

      printWindow.document.write('</tr>');
    }

    printWindow.document.write('</table>');

    printWindow.document.write('<table id="sum">');
    printWindow.document.write('<tr>');
    printWindow.document.write('<td>Sum Items</td>');
    printWindow.document.write('<td>');
    printWindow.document.write(sumItems);
    printWindow.document.write('</td>');

    printWindow.document.write('<td>Sum Total:</td>');
    printWindow.document.write('<td>');
    printWindow.document.write("Rs.", sumTotal);
    printWindow.document.write('</td>');
    printWindow.document.write('</tr>');
    printWindow.document.write('</table>');
    printWindow.document.write('<hr>')
    printWindow.document.write('<center>Thank You...</center>')
    printWindow.document.write('<center>Dr. P.Ranjith Kumar Dermatologist...</center>')
    //break
    printWindow.document.write('<br>'); printWindow.document.write('<br>');
    printWindow.document.write('<br>'); printWindow.document.write('<br>');

    //break
    printWindow.document.write('<center><h1>Amra Skin Care</h1></center>');
    printWindow.document.write('Merchent Copy')
    printWindow.document.write('<hr>')
    printWindow.document.write("Date:", dateTime);
    printWindow.document.write("Bill No:", B_Number)
    printWindow.document.write('<table>');
    printWindow.document.write('<tr><td>Qty</td><td>Items</td><td>MRP</td><td>Total</td><tr>');
    for (let i = 1; i < viewcart_table.rows.length; i++) {
      let qty = viewcart_table.rows[i].cells[2].children.qty.value;
      let Mname = viewcart_table.rows[i].cells[1].innerHTML;
      let M_mrp = viewcart_table.rows[i].cells[3].innerHTML;
      let total = viewcart_table.rows[i].cells[4].innerHTML;

      // console.log();
      printWindow.document.write('<tr>');
      printWindow.document.write('<td>');
      printWindow.document.write(qty);
      printWindow.document.write('</td>');

      printWindow.document.write('<td>');
      printWindow.document.write(Mname);
      printWindow.document.write('</td>');

      printWindow.document.write('<td>');
      printWindow.document.write(M_mrp);
      printWindow.document.write('</td>');

      printWindow.document.write('<td>');
      printWindow.document.write(total);
      printWindow.document.write('</td>');

      printWindow.document.write('</tr>');
    }


    printWindow.document.write('</table>');

    printWindow.document.write('<table id="sum">');
    printWindow.document.write('<tr>');
    printWindow.document.write('<td>Sum Items</td>');
    printWindow.document.write('<td>');
    printWindow.document.write(sumItems);
    printWindow.document.write('</td>');

    printWindow.document.write('<td>Sum Total:</td>');
    printWindow.document.write('<td>');
    printWindow.document.write("Rs.", sumTotal);
    printWindow.document.write('</td>');
    printWindow.document.write('</tr>');
    printWindow.document.write('</table>');
    printWindow.document.write('<hr>')
    printWindow.document.write('<center>Thank You...</center>')
    printWindow.document.write('<center>Dr. P.Ranjith Kumar Dermatologist...</center>')


    printWindow.document.write('</body>');
    printWindow.document.write('</html>');
    printWindow.document.close();
    printWindow.print();




  }

</script>
{%endblock js%}